function [x_fv,ecg_locs1,ecg_locs2,x_fv1,x_fv2,l_yes] = get_fv5(ecg_data_f,ecg_data_o,ppg_data,Fs)

    l_yes = 0;
    x_fv1 = [];
    x_fv2 = [];

    ecg_data1 = ecg_data_f((290*Fs)+1 : 300*Fs);
    ecg_data1 = ecg_data1 - mean(ecg_data1);
    ecg_data2 = ecg_data_o((290*Fs)+1 : 300*Fs);
    ecg_data2 = ecg_data2 - mean(ecg_data2);
    
    ppg_data1 = ppg_data((290*Fs)+1 : 300*Fs);
    ppg_data1 = ppg_data1 - mean(ppg_data1);

    ecg_len = length(ecg_data_f);

    if(ecg_len > (300*Fs))
        ecg_data1_0 = ecg_data_f((300*Fs)+1:310*Fs);
        ecg_data1_0 = ecg_data1_0 - mean(ecg_data1_0);
        ecg_data2_0 = ecg_data_o((300*Fs)+1:310*Fs);
        ecg_data2_0 = ecg_data2_0 - mean(ecg_data2_0);

        ecg_data1_1 = ecg_data_f((310*Fs)+1:320*Fs);
        ecg_data1_1 = ecg_data1_1 - mean(ecg_data1_1);
        ecg_data2_1 = ecg_data_o((310*Fs)+1:320*Fs);
        ecg_data2_1 = ecg_data2_1 - mean(ecg_data2_1);
        
        ppg_data1_0 = ppg_data((300*Fs)+1 : 310*Fs);
        ppg_data1_0 = ppg_data1_0 - mean(ppg_data1_0);
        ppg_data1_1 = ppg_data((310*Fs)+1 : 320*Fs);
        ppg_data1_1 = ppg_data1_1 - mean(ppg_data1_1);

        l_yes = 1;
    end

    [x_fv,ecg_locs1,ecg_locs2] = get_features(ecg_data1,ecg_data2,ppg_data1,Fs);
    if(l_yes)
        [x_fv1,~,~] = get_features(ecg_data1_0,ecg_data2_0,ppg_data1_0,Fs);
        [x_fv2,~,~] = get_features(ecg_data1_1,ecg_data2_1,ppg_data1_1,Fs);
    end
end

function [x_fv,ecg_locs1,ecg_locs2] = get_features(ecg_data1,ecg_data2,ppg_data1,Fs)

    lp_ecg = butter_bidir(1,ecg_data1,Fs,2,'low');
    ecg_data1 = ecg_data1 - lp_ecg;
    lp_ecg = butter_bidir(1,ecg_data2,Fs,2,'low');
    ecg_data2 = ecg_data2 - lp_ecg;

    [flat1,~] = verify_flat(ecg_data1,Fs);
    [flat2,~] = verify_flat(ecg_data2,Fs);
    [flatp,~] = verify_flat(ppg_data1,Fs);
    
    ecg_locs1 = [];
    ecg_locs2 = [];

    if(~flat1)
        [ecg_locs1] = get_rpeaks(ecg_data1,Fs,1);
    end
    if(~flat2)
        [ecg_locs2] = get_rpeaks(ecg_data2,Fs,1);
    end

    l=1;
    ebpm1_17 = [0];
    
    ecgloc_off1 = 16;
    if(length(ecg_locs1) >= 17)
        ecgloc_off1 = 16;
    elseif(length(ecg_locs1) >= 11)
        ecgloc_off1 = 10;
    end
    
    ecgloc_off2 = 16;
    if(length(ecg_locs2) >= 17)
        ecgloc_off2 = 16;
    elseif(length(ecg_locs2) >= 11)
        ecgloc_off2 = 10;
    end
        
    for i=1:1:length(ecg_locs1)-ecgloc_off1;
        
        ecg_beats = ecg_locs1(i:i+ecgloc_off1);
        diff_locs = diff(ecg_beats);
        mean_locs = mean(diff_locs);
        ebpm1_17(l) = 60*Fs/mean_locs;
        l=l+1;
        
    end
    max_ebpm1 = max(ebpm1_17);
    l=1;
    ebpm2_17 = [0];
    for i=1:1:length(ecg_locs2)-ecgloc_off2;
        
        ecg_beats = ecg_locs2(i:i+ecgloc_off2);
        diff_locs = diff(ecg_beats);
        mean_locs = mean(diff_locs);
        ebpm2_17(l) = 60*Fs/mean_locs;
        l=l+1;
        
    end
    
    max_ebpm2 = max(ebpm2_17);
    if((~flat1) && (~flat2))
        max_ebpm = max([max_ebpm1,max_ebpm2]);
    else
        if(~flat1)
            max_ebpm = max_ebpm1;
        else
            max_ebpm = max_ebpm2;
        end
    end
    
    if(~flatp)

        ppg_valid = 0;
        ppg_data1 = detrend(ppg_data1);
        
        ppg_data_diff = diff(ppg_data1);
        ppg_data_diff = (smooth(ppg_data_diff))';
        ppg_data_diff = ppg_data_diff/max(ppg_data_diff);
        
        [~,ppg_locs] = findpeaks(ppg_data_diff,'MINPEAKHEIGHT',0.1,'MINPEAKDISTANCE',ceil(0.2*Fs));
        
        ppg_len = length(ppg_data1);
        diff_locs = [ppg_locs ppg_len];
        diff_difflocs = diff(diff_locs);
        
        if(length(diff_difflocs) > 1)
            
            std_difflocs = std(diff_difflocs);
            
            if(std_difflocs < 40)
                ppg_valid = 1;
            end
        end
        m=1;
        pbpm_17 = [0];
        for i=1:1:length(ppg_locs)-16;

            ppg_beats = ppg_locs(i:i+16);
            diff_locs = diff(ppg_beats);
            mean_locs = mean(diff_locs);
            pbpm_17(m) = 60*Fs/mean_locs;
            m=m+1;

        end
        
        if(ppg_valid == 1)
            max_pbpm = max(pbpm_17);
        else
            max_pbpm = max_ebpm;
        end
    else
        max_pbpm = max_ebpm;
    end
    
    x_fv = [max_ebpm max_pbpm];
end
